/* tslint:disable */
/**
 * This file was automatically generated by json-schema-to-typescript.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run json-schema-to-typescript to regenerate this file.
 */

/**
 * Information about an exploration event (mouse move, scrolling, keyboard navigation, ...)
 */
export type ExplorationEvent = string;
/**
 * Information about an action event (mouse click, keystroke, drag & drop, ...)
 */
export type ActionEvent = string;

/**
 * A collection of LOMs and events captured during a certain time frame
 */
export interface SessionCapture {
  /**
   * Start time of this session chunk
   */
  ts: number;
  /**
   * Unique id identifying the current session
   */
  sid: string;
  /**
   * Unique id identifying anonymously the current user
   */
  uid?: string;
  /**
   * List of LOMs captured in this session chunk
   */
  loms?: (Lom | LomRef)[];
  /**
   * List of exploration events captured in this session chunk
   */
  ee?: ExplorationEvent[];
  /**
   * List of action events captured in this session chunk
   */
  ae?: ActionEvent[];
  /**
   * List of page navigation load time measures
   */
  pnt?: NavigationTiming[];
  /**
   * List of page resource load time measures
   */
  prt?: ResourceTiming[];
  [k: string]: unknown;
}
/**
 * Specification of the wireframe of a single Web page
 */
export interface Lom {
  /**
   * Unique ID for this LOM in the context of current session
   */
  id?: string;
  /**
   * Instant of this LOM capture relative to the session chunk timeStamp
   */
  ts: number;
  /**
   * Global page width
   */
  w: number;
  /**
   * Global page height
   */
  h: number;
  /**
   * Page title to help identify the LOM
   */
  t?: string;
  /**
   * Page URL to help identify the LOM
   */
  u?: string;
  /**
   * Root zone corresponding to the  HTML body element
   */
  r: {
    /**
     * Unique ID of this zone in its LOM
     */
    id?: string;
    /**
     * Coordinates of the area occupied by this zone relative to the parent zone
     */
    b: [number, number, number, number];
    /**
     * List of children zones of this zone
     */
    c?: Zone[];
    /**
     * Styling information for zone rendering
     */
    s?: {
      /**
       * Background styling in CSS format
       */
      bg?: string;
      /**
       * Border styling in CSS format
       */
      b?: string;
    };
  };
  [k: string]: unknown;
}
/**
 * Representation of a zone on screen
 */
export interface Zone {
  /**
   * Unique ID of this zone in its LOM
   */
  id?: string;
  /**
   * Coordinates of the area occupied by this zone relative to the parent zone
   */
  b: [number, number, number, number];
  /**
   * List of children zones of this zone
   */
  c?: Zone[];
  /**
   * Styling information for zone rendering
   */
  s?: {
    /**
     * Background styling in CSS format
     */
    bg?: string;
    /**
     * Border styling in CSS format
     */
    b?: string;
  };
}
/**
 * Reference to a LOM previously captured
 */
export interface LomRef {
  /**
   * Instant of this LOM capture relative to the session chunk timeStamp
   */
  ts: number;
  /**
   * ID of the referenced LOM
   */
  ref: string;
}
/**
 * Measure the loading time of a page
 */
export interface NavigationTiming {
  /**
   * Instant of this NavigationTiming capture relative to the session chunk timeStamp
   */
  ts?: number;
  /**
   * Timestamp when the page starts loading
   */
  ots?: number;
  /**
   * Timestamp where the page is usable but external resources are not loaded
   */
  its?: number;
  /**
   * Timestamp where the page and all its resources are completely loaded
   */
  cts?: number;
  /**
   * Timestamp of the event that triggered the page change
   */
  ets?: number;
  /**
   *  Elapsed time in seconds to load the page without external files
   */
  ilt?: number;
  /**
   * Elapsed time in seconds to load the page with all external files already loaded
   */
  clt?: number;
  /**
   * Id of the lom where the triggering event was produced
   */
  from?: string;
  /**
   * Id of the lom where the loading time is analyzed
   */
  to?: string;
  [k: string]: unknown;
}
/**
 * Measures the loading time of external resources of the pages.
 */
export interface ResourceTiming {
  /**
   * Instant of this ResourceTiming capture relative to the session chunk timeStamp
   */
  ts?: number;
  /**
   * Name for the performance entry
   */
  n?: string;
  /**
   * First timestamp recorded for the performance entry
   */
  st?: number;
  /**
   * Timestamp after the browser receives the last byte of the resource
   */
  re?: number;
  /**
   * Type of performance metric that this entry represents
   */
  et?: string;
  /**
   * Duration of the performance entry
   */
  d?: number;
  [k: string]: unknown;
}
